theory Ceta_Checker
imports Ceta
begin

subsection {* User exceptions in generated code *}
(* FIXME:  will be moved to Main *)

definition error :: "String.literal \<Rightarrow> 'a \<Rightarrow> 'a" 
where [code del]: "error msg x = x"

code_const error
  (Eval "(fn msg =>/ fn x =>/ error msg)")

code_reserved Eval error

subsection {* Checker *}

text {* Assemble a checker with a simple interface from the bits and pieces provided by IsaFoR. *}

(* FIXME: Shouldn't the errors be uniform (string vs. show)??? *)
fun release_shows_error :: "'a \<Rightarrow> shows + 'a \<Rightarrow> 'a"
where
  "release_shows_error d (Inl msg) = error (implode (msg [])) d"
| "release_shows_error d (Inr x) = x"

fun release_string_error :: "'a \<Rightarrow> string + 'a \<Rightarrow> 'a"
where
  "release_string_error d (Inl msg) = error (implode msg) d"
| "release_string_error d (Inr x) = x"

definition ceta_checker :: "(string, string) rules \<Rightarrow>
  (string, label_type, string) TRSProof \<Rightarrow> bool"
where
  "ceta_checker trs prf = 
     release_shows_error False 
       (checkTRSProof (shows_string ''1'') (init_lab_rules trs) 0 prf
        \<guillemotright>= (\<lambda>x. return True))"

lemma ceta_checker: assumes check: "ceta_checker trs prf" shows "SN (rstep (set trs))"
proof (cases "checkTRSProof (shows_string ''1'') (init_lab_rules trs) 0 prf")
  case Inl with check show ?thesis by (auto simp: error_def ceta_checker_def)
next
  case Inr
  then have "isOK (checkTRSProof (shows_string ''1'') (init_lab_rules trs) 0 prf)" by simp
  note t = checkTRSProofSound[OF this, simplified map_trs.simps]
  show "SN (rstep (set trs))"
    by (rule decr_SN_to_SN) (insert t, auto simp: map_trs.simps)
qed

definition dummy_proof :: "(string, label_type, string) TRSProof"
where "dummy_proof = RisEmpty"

definition parse_TRSProof :: "string \<Rightarrow> Code_Evaluation.term"
where "parse_TRSProof s = 
  Code_Evaluation.term_of 
    (case (release_string_error (TRSProof [] dummy_proof) (parseCertProblem s)) of
      TRSProof _ prf \<Rightarrow> prf
     | _ \<Rightarrow> error (STR ''not a termination proof'') dummy_proof)"

ML {*
structure Ceta_Parser =
struct
  val read_cpf = 
    String.explode
    #> @{code parse_TRSProof}
    #> Pattern.rewrite_term @{theory} 
      [(term_of @{cpat "Frct (?x, ?y)"}, term_of @{cpat "Fract ?x ?y"})] []
end
*}

end
