theory Loga
imports "../TermFun"
begin

fun half where
  "half 0 = 0"
| "half (Suc 0) = 0"
| "half (Suc (Suc n)) = Suc (half n)"

(*
function log where
  "log n = (if n = 0 then Suc 0
   else Suc (log (half n)))"
by pat_completeness auto
*)

function log where
  "log n = (case half n of 0 \<Rightarrow> 0 | Suc m \<Rightarrow> Suc (log (Suc m)))"
by pat_completeness auto

define_trs half.simps
define_trs (no_sim) log.psimps

termination log
apply (trs_reduce log)
apply (simp only: all_trs_defs set_list_conv)
export_termination_problem "Examples/log.xml"
apply (ceta_import_proof "Examples/proofs/log.proof.xml")
apply ceta_eval
(*apply ceta_simp*)
done


end
